diff --git a/src/backend/catalog/system_views.sql b/src/backend/catalog/system_views.sql
index 4fc5d5a..28707ee 100644
--- a/src/backend/catalog/system_views.sql
+++ b/src/backend/catalog/system_views.sql
@@ -151,7 +151,7 @@ CREATE VIEW pg_indexes AS
         C.relname AS tablename,
         I.relname AS indexname,
         T.spcname AS tablespace,
-        pg_get_indexdef(I.oid) AS indexdef
+        pg_get_indexdef(X.indexrelid) AS indexdef
     FROM pg_index X JOIN pg_class C ON (C.oid = X.indrelid)
          JOIN pg_class I ON (I.oid = X.indexrelid)
          LEFT JOIN pg_namespace N ON (N.oid = C.relnamespace)
diff --git a/src/test/regress/expected/rules.out b/src/test/regress/expected/rules.out
index ad44ae2..9285d4f 100644
--- a/src/test/regress/expected/rules.out
+++ b/src/test/regress/expected/rules.out
@@ -1342,7 +1342,7 @@ pg_indexes| SELECT n.nspname AS schemaname,
     c.relname AS tablename,
     i.relname AS indexname,
     t.spcname AS tablespace,
-    pg_get_indexdef(i.oid) AS indexdef
+    pg_get_indexdef(x.indexrelid) AS indexdef
    FROM ((((pg_index x
      JOIN pg_class c ON ((c.oid = x.indrelid)))
      JOIN pg_class i ON ((i.oid = x.indexrelid)))
